== Changelog ==

= 1.0.402 =

* Improves the code that generates the forms builder.
* Includes new filter cpcff_custom_tags (Professional, Developer and Platinum versions)
* Modifies the PDF Generator add-on allowing to enter the <%pdf_generator_url%> tag into the notification emails and thank you pages. The tag would be replaced with the URL to the PDF file (Platinum versions)

= 1.0.401 =

* Modifies some database's columns to increase their sizes.
* Adds a random parameter to the thank you page's URL to prevent it be cached (Professional, Developer and Platinum versions)

= 1.0.400 =

* Modifies the controls to allow using other fields in the form as their predefined values.

= 1.0.399 =

* Modifies the forms builder.
* It has been tested in WP 5.5

= 1.0.398 =

* Includes pre tags to prevent other plugins pre-process our plugin's scripts.
* Fixes a conflict with Lottie.
* Fixes an issue with the conditional attributes in the fields tags used in the notification emails and thank you pages (Professional, Developer and Platinum versions)
* Includes a new data source alternative in the recordset fields for reading the records from a javascript variable or JSON file (Developer and Platinum versions)

= 1.0.397 =

* Includes the exclude attribute in the hidden fields too.

= 1.0.396 =

* Now edit the forms and equations is easier. The plugin includes a frame with the field's name directly on the dashboard.
* Fixes an issue in the summary control. If there is a date-time field with the date component disabled, the summary will display only the time.
* Fixes an issue with the progress bar in the template 07 for multi-pages forms.
* Modifies the IF operation to prevent an error caused by the optimization algorithm of the WP-Optimize plugin.
* Includes a new attribute in the fields' settings to exclude them from submissions and notification emails (Professional, Developer, and Platinum versions).

= 1.0.395 =

* Includes a new option in the plugins settings to prevent the conflicts with the optimization plugins.
* Modifies the WooCommerce add-on (Developer and Platinum versions).
* Fixes a minor issue in the payment gateways add-ons (Platinum version).

= 1.0.394 =

* Fixes an issue formatting the calculated fields results.

= 1.0.393 =

* Modifies the pagination process.

= 1.0.392 =

* Fixes an issue parsing the fields' values.
* Modifies the WooCommerce add-on to allow the integration with the 'WooCommerce Product Add-Ons Ultimate' plugin (Developer and Platinum versions of the number)

= 1.0.391 =

* Includes additional header tags when the form URL is loaded directly.

= 1.0.390 =

* Modifies the calculated fields to allow formatting their values dynamically when they are editable.
* Optimizes the plugin's execution reducing the time that takes generate the form.
* Modifies the WooCommerce add-on allowing the integration with other plugins of the ecosystem, like WooCommerce Booking (Developer and Platinum versions of the plugin).

= 1.0.389 =

* Modifies the radio buttons and checkbox fields to fix some conflicts with third party themes.

= 1.0.388 =

* Begins a process of the plugin's optimization, removing unnecessary code.
* Fixes an issue in the predefined template 13.

= 1.0.387 =

* Fixes two issues in the tooltips with the instructions for users. It prevents the tooltips be displayed over the radio buttons and checkbox configured as side-by-side, and prevents the tooltips be cut-off on mobiles and small screens.
* Fixes an issue in the IGNOREFIELD and ACTIVATEFIELD operations to prevent infinite loops.
* Implements the if_paid parameter in the [CP_CALCULATED_FIELDS_RESULT] and [CP_CALCULATED_FIELDS_RESULT_LIST] shortcodes to load only the paid entries (Professional, Developer and Platinum versions of the plugin).

= 1.0.386 =

* Includes a new attribute in the currency fields to allow truncate the values entered by the users to two decimal places.
* Includes a new modifier to be used with the fields' names in the equations (|n) to prevent the fields' names be replaced by their values (Ex. fieldname1|n). Now it is possible to call the getField operation as follows: getField(fieldname1|n)
* Modifies the plugin's styles to prevent a conflict with third party themes.
* It does not set the focus by default in multi-pages forms when are loaded from mobiles devices.

= 1.0.385 =

* Fixes a style conflict.

= 1.0.384 =

* Modifies the behavior of the instructions for the users, allowing to display them on icons.
* Fixes a conflict with a third party plugin.
* Modifies the WooCommerce add-on. Includes a checkbox to replace the 'Add To Cart' buttons in the pages of the shop and archives by 'View Product' buttons (Developer and Platinum versions of the plugin).

= 1.0.383 =

* Includes additional validations rules to identify possible conflicts with Hummingbird.

= 1.0.382 =

* Modifies the HTML Content field to integrate a HTML editor into the Content attribute.

= 1.0.381 =

* Modifies the container fields (DIV and Fieldsets) allowing rearrange the fields in columns.
* Fixes an issue with the fields' focus in the multi-pages forms.
* Allows to get the length of numbers.
* Includes the LATLNG operation in the DISTANCE operations module to get the latitude and longitude corresponding to an address, or the text FAIL (Developer and Platinum versions of the plugin).

= 1.0.380 =

* Fixes an issue displaying the captcha preview.

= 1.0.379 =

* Modifies some texts in the plugin's interface.
* Modifies some CSS rules.
* Improves the plugin's registration process (Professional, Developer, and Platinum versions)
* Modifies the PayTM add-on (Platinum version)

= 1.0.378 =

* Fixes an issue extracting the website's domain when the code is running as CLI.

= 1.0.377 =

* Improves the plugin's performance.
* Removes unnecessary attributes from the form's settings.
* Modifies some styles.
* Allows identify easier the errors with the notification emails, generating an entry in the Error Logs  (Professional, Developer, and Platinum versions of the plugin).
* Modifies the PrintFriendly add-on, allowing configure the emails where attach the pdf files.

= 1.0.377 =

* Improves the plugin's performance.
* Removes unnecessary attributes from the form's settings.
* Modifies some styles.
* Allows identify easier the errors with the notification emails, generating an entry in the Error Logs  (Professional, Developer, and Platinum versions of the plugin).
* Modifies the PrintFriendly add-on, allowing configure the emails where attach the pdf files.

= 1.0.376 =

* Modifies the module that loads the plugin's resources.
* Modifies the module to export the forms. Now the forms list includes the form's id in front of forms' names, and the name of generated file, has the structure: export_id_yyyy-mm-dd_hhiiss.cpfm (Professional, Developer and Platinum versions of the plugin)
* Modifies the Users Permissions add-on to support the new attributes in the submissions shortcode: from, to, limit, order (Developer and Platinum versions of the plugin)
* Includes the DMSTODD operation in the Distance operations module to convert degrees, minutes and seconds values into decimal degrees (Developer and Platinum versions of the plugin).
* Modifies the SagePay add-on (Platinum version of the plugin)

= 1.0.375 =

* Includes additional validations rules to identify possible conflicts with other optimization plugins.
* Fixes an encoding issue with some ampersand symbols in generated URLs.

= 1.0.374 =

* It makes easier debugging the errors in the equations.
* Includes the new CSS class hide-strong, it applies the display:none with the !important modifier.
* Includes two new operations in the Managing Fields module, ACTIVATEFIELD and IGNOREFIELD for activating and ignoring the fields programmatically.
* Reduces the space between fields after the forms' submissions.

= 1.0.373 =

* Includes additional validations rules to identify possible conflicts with other optimization plugins.

= 1.0.372 =

* Includes additional validations rules to identify possible conflicts with other optimization plugins.
* Includes the role attribute in the [CP_CALCULATED_FIELDS_RESULT_LIST] shortcode to display the submissions list for specific users roles.

= 1.0.371 =

* This update modifies the plugin's code to prevent poorly implemented optimization plugins affect the forms. Some optimization plugins do not distinguish between a javascript comment and a regular expression, breaking the plugins code in the optimization process.

= 1.0.370 =

* Includes two new operations: SUM and CONCATENATE. In javascript the plus operator is overloaded, it is used to sum numbers and concatenate texts, these operations solve the ambiguity.
* Includes a new section in the settings page of the plugin to identify possible causes of conflicts with third party plugins.

= 1.0.369 =

* Fixes a compatibility issue with the new version of Gutenberg editor.

= 1.0.368 =

* Includes the generateURL operation in the URL Operations Module to generate a valid URL, given a base URL, a plain object for parameters, and hash.
* Fixes the documentation of operations modules.
* Fixes an issue in the advanced equations editor that was ignoring some operations modules.

= 1.0.367 =

* Includes two new operations in the URL Operations Module: getURLHash and getURLPath
* Includes a new attribute in the troubleshoot area to fix the wrong encoding of notification emails (Professional, Developer and Platinum versions of the plugin).

= 1.0.366 =

* Some few changes in the interface.
* Allows to use the raw values of fields for filtering in the datasource fields: <%fieldname1|r%> (Developer and Platinum versions of the plugin).

= 1.0.365 =

* Includes new options into the settings page of the plugin for controlling the direct access to the forms and their APM versions.

= 1.0.364 =

* Implements the new operation LCM: least common multiple between two numbers.

= 1.0.363 =

* Modifies the next/previous page behavior, in multi-pages forms, for jumping pages without active fields.

= 1.0.362 =

* Fixes a conflict with third party plugins like MailChimp for WooCommerce.

= 1.0.361 =

* Improves the accessibility, duplicating the Preview button over the forms builder.
* Fixes an issue cloning the fields in the forms builder.
* Fixes an issue in the DATEDIFF operation (Developer and Platinum versions of the plugin)
* Modifies the server side code of datasource fields (Developer and Platinum versions of the plugin)

= 1.0.360 =

* Fixes an issue in the cffProxy operation.

= 1.0.359 =

* Modifies the styles to improve the forms appearance on small screens, when they are configure as left or right aligned.

= 1.0.358 =

* Modifies the database structure to allow the implementation of very long forms, with hundreds of fields.

= 1.0.357 =

* Fixes an issue in the expanded CSS editor, where the latest rows were being hidden or unaccessible.

= 1.0.356 =

* Includes a new icon over the CSS editor in the Form Settings tab, to expand (and collapse) the CSS editor to the viewport size, doing the CSS edition easier.

= 1.0.355 =

* Includes the URL Operations Module. The operations in this module allow to obtain the URLs of pages and their parameters, or the redirection to other pages.

= 1.0.354 =

* Fixes a possible vulnerability (fortunately only accessible by the website's administator). Many thanks to Ben Armstrong from https://Spider-security.co.uk  for the detection of the vulnerability.
* Includes a new method for accessing to the jQuery representation of a field from the equations. Ex: to get the jQuery representation of the fieldname123 field: getField(123).jQueryRef();
* Includes new logs in the dependencies to detect possible issues easier.
* Includes new filters in the notification and confirmation emails, for accessing to the subjects and messages: cpcff_notification_email_subject, cpcff_notification_email_message, cpcff_confirmation_email_subject and cpcff_confirmation_email_message (Professional, Developer, and Platinum versions of the plugin)

= 1.0.353 =

* Fixes an issue in the CFFPROXY operation of the Third-party Connection module.

= 1.0.352 =

* Modifies the settings of some controls to adjust them to the latest version of WordPress.

= 1.0.351 =

* Modifies the module that generates the froms revisions.
* Modifies the MailChimp and EDD modules (Platinum version of the plugin).

= 1.0.350 =

* Improves the appearance of the dependencies.
* Modifies the access to the plugin's resources.

= 1.0.349 =

* Modifies the calculation's module for triggering the equationsQueueEmpty event when the queue of equations be emptied.
* Modifies the calculate buttons to allow display a calculation in progress indicator until all equations be evaluated.
* Prevents the form be submitted if there are equations pending to be evaluated, even if they dependen on external apis or services (Professional, Developer and Platinum versions of the plugin)
* Modifies the DISTANCE operations module, to tell the plugin the Google Maps APIs are being instantiated, and the evaluation of the equations is pending (Developer and Platinum versions of the plugin)

= 1.0.348 =

* Improves the appearance of the forms list in the medium-size screens.

= 1.0.347 =

* Modifies the validation on Currency and Number fields.

= 1.0.346 =

* Fixes some warnings.

= 1.0.345 =

* Fixes an issue in the number fields when the percent option is selected as their formats.
* Modifies the forms list to be ordered by their IDs in ascending way.
* Fixes an issue in the new forms, selecting the calculated field through the Request Cost attribute by default.
* Includes new class names into the Dashboard widget and the messages section (Professional, Developer and Platinum versions of the plugin)

= 1.0.344 =

* Improves the goToPage operation to allow jumping to a sepecific page in multi-pages forms, from button fields. Ex: for jumping to the third page in the form (the pages indexes start in 0), insert a button in the form and enter as its onclick event the piece of code: fbuilderjQuery.fbuilder.goToPage({form:this.form, to:2});

= 1.0.343 =

* Fixes an issue in the dependencies definition in the Radio Buttons, Checkbox, and DropDown fields.

= 1.0.342 =

* Modifies the CSS rules to improve the user experience in the forms builder when it is accessed from small screens like smartphones.

= 1.0.341 =

* Modifies the textarea and password controls.

= 1.0.340 =

* Fixes a warning in the cff_config file.
* Fixes a conflict between the DIVI integration module and the Classic WordPress Editor.
* Removes unnecessary code from the calculated fields.

= 1.0.339 =

* Modifies the integration with DIVI Page Builder.
* Allows leading with zeros the itemnumber passing as tag parameter the length attribute (length={{6}}) (Professional, Developer and Platinum versions)

= 1.0.338 =

* Modifies the Media fields. Includes a new attribute allowing to disable the download control from the players in the public forms.
* Modifies the cp_calculatedfieldsf_insert_in_database.php file to allow debugging easier the customized insertion queries (Developer and Platinum versions of the plugin)

= 1.0.337 =

* Includes a new form template, based on the styles of the new WP53.

= 1.0.336 =

* Modifies the code of the plugin for allowing the compatibility with outdated versions of PHP.

= 1.0.335 =

* Fixes an issue in forms when the calculated fields are evaluated the first time.

= 1.0.334 =

* Modifies the dependencies in the calculated fields to allow the use of value and value|r (for raw values) in the manual definition of dependency rules.

= 1.0.333 =

* Includes specific buttons in the Logical Operations module to for the operators: equal, not equal, less than, less than or equal to, greater than, greater than or equal.

= 1.0.332 =

* Includes a specific DIVI module to allow the insertion of the form's shortcode from the DIVI Builder.

= 1.0.331 =

* Modifies the module that evaluate all equations, and the dependencies, improving the forms performance.

= 1.0.330 =

* Modifies the 'Equal To' attribute in the controls: Single Line Text, Email and Password for all versions of the plugin, and the controls: Line Text DS, Email DS in the Developer and Platinum versions.

= 1.0.329 =

* Modifies the CSS editor.
* Includes the new filter: cpcff_price that allows modify the calculated price. This filter receives two parameters: the calcualted price, and an array with the list of fields and their values (Professional, Developer and Platinum versions of the plugin).
* Modifies the SERVER-SIDE EQUATIONS add-on. The new version includes a new section in the forms' settings to allow calculate the final price through a server side equation after the form be submitted (Developer and Platinum versions of the plugin).

= 1.0.328 =

* Replaces the 'Customize Form Design' attribute in the 'Form Settings' tab by a real CSS editor, with auto-completing, syntax highlighting, and error checking.

= 1.0.327 =

* Improves the definition of the dependencies in the Radio Buttons, Checkbox and DropDown fields.
* Modifies the script blocks to prevent that some optimization plugins affect the forms.

= 1.0.326 =

* Modifies the forms' validations module to restrict the error messages to the form's scope, and not to the page's scope. At the page's scope the error messages defined by the last form in the page, affect to the other forms in the same page.

= 1.0.325 =

* Modifies the way the plugin manages the session variables.
* Allows to includes results shortcodes for multiple forms in the thank you page. Furthermore, includes the if_latest attribute in the results shortcode (Professional, Developer and Platinum versions of the plugin).

= 1.0.324 =

* Modifies the number control. Includes the percent option as the field's formats. The numbers configured as percent should not be divide by 100 in the equations.

= 1.0.323 =

* Modifies the controls: checkbox and radio buttons to prevent a conflict with those themes that manipulate the DOM of pages at runtime to customize the appearance of these fields.

= 1.0.322 =

* Modifies the module that manage the browser's history. Now if there is a multi-pages form, and the browser's persistence is enabled on it, if the user refreshes the browser when he/she is populating the fields of page X, the plugin will pre-fill the form's fields, and will jump to the page X automatically.

= 1.0.321 =

* Fixes some notices related with the servers' settings.

= 1.0.320 =

* Modifies the Radio Buttons, Checkbox and DropDown controls. Implements in them the setChoices method to replace their choices programmatically.
* Modifies the Calculated fields to improve the process that evaluates the equations.
* Modifies the module that check the dependencies.

= 1.0.319 =

* Fixes an issue in the integration with WPBakery Page Builder.

= 1.0.318 =

* Modifies the Advanced Equations module.
* Improves the performance of DS fields (Developer and Platinum versions of the plugin).
* Modifies the WooCommerce add-on to include the form in the products' pages, even if the products' prices were left in blank in the WooCommerce settings (Developer and Platinum versions of the plugin).
* Modifies the RedSys add-on to prevent the payments fail if the "Product name" attribute was left in blank in the form's settings (Platinum version of the plugin).

= 1.0.317 =

* Modifies the Upload File field.
* Modifies the Users Permissions add-on to prevent the files uploaded previously being lost when the uses edit  their submissions.

= 1.0.316 =

* Fixes a conflict with other plugins that use the forms builder.
* Fixes an issue between the module that pre-fills the form's fields and the dependencies.
* Includes the "callback" attribute in the fields tags, allowing to apply escape functions before the tags' replacement (Professional, Developer and Platinum versions of the plugin).
* Implements the "STRAIGHT" mode in the "DISTANCE" operation to determine the straight line distance between addresses (Developer and Platinum versions of the plugin).
* Implements the attribute: events_per_page into the [CP_CALCULATED_FIELDS_RESULT_LIST] shortcode to allow paginate the submissions lists (Professional, Developer and Platinum versions of the plugin).
* Implements the attribute: events_per_page into the [CP_CALCULATED_FIELDS_USER_SUBMISSIONS_LIST] shortcode of the Users Permissions add-on for controlling the number of items per page (Developer and Platinum versions of the plugin).
* Allows to insert the [CP_CALCULATED_FIELDS_USER_SUBMISSIONS_LIST] shortcode with the format: [CP_CALCULATED_FIELDS_USER_SUBMISSIONS_LIST] content [/CP_CALCULATED_FIELDS_USER_SUBMISSIONS_LIST]. In this way  the content takes precedence over the "Summary" attribute in the form's settings (Developer and Platinum versions of the plugin).

= 1.0.315 =

* Fixes some minor issues.
* Implements a specific element to insert the forms using WPBakery Page Builder.

= 1.0.314 =

* Fixes an issue with the tooltips in multi-pages forms.
* Fixes an issue assigning the default values in the Date/Time fields, specifically populating the time component.

= 1.0.313 =

* Improves the integration with the different pages builders: Gutenberg, SiteOrigin, Beaver Page Builder, Elementor.
* Includes a new module in the Beaver Page Builder for generating the javascript variables.
* Fixes an issue in the PrintFriendly add-on when there are multiple notification emails (Platinum version of the plugin).

= 1.0.312 =

* Modifies the module that generates the Captcha.

= 1.0.311 =

* Improves the generated form reducing its code.
* Fixes an common issue caused by the users that enter comma signs as separator of class names in the 'Add Custom Coding Keywords' attributes of fields settings.
* Fixes an issue in the signature add-on. It was hiding the signature when the submission is being edited by the 'Users Permissions' add-on.

= 1.0.310 =

* Fixes a conflict between the Forms Preview module and some popular themes.

= 1.0.309 =

* Modifies the number and slider controls to allow entering the blank character as the thousands separator.

= 1.0.308 =

* Fixes an issue in the validation rules of Date/Time fields when the date component is disabled.
* Allows to preserves the 12 hours format in the summary fields (and in the notification emails and the thank you pages in the commercial versions of the plugin).
* Modifies the integration with the Gutenberg editor.
* Fixes an issue in the Date/Time operations module (Developer and Platinum versions of the plugin).

= 1.0.307 =

* Modifies the cffProxy operation for accepting not only camel-case convention, but lower can uppercase too: cffproxy and CFFPROXY.
* Modifies the MailChimp add-on to allow assigning tags the new members (Platinum version of the plugin).

= 1.0.306 =

* Modifies the autocomplete module to include the requirements of latest versions of browsers.
* Modifies the slider control to circumvent some errors caused by invalid values entered by the form creator.
* Includes the Chart.js operations module to integrate ChartJS in the form (Developer and Platinum versions of the plugin)

= 1.0.305 =

* Includes the 'Connecting with thirds' module, with the cffProxy operation that allows the use of third party functions in the equations.

= 1.0.304 =

* Fixes an issue in the module that associates fields.

= 1.0.303 =

* Includes a specific module to allow the integration with Beaver Builder.

= 1.0.302 =

* Fixes an issue where the error message overlap the acceptance control when the validation rule fails in the submit action.

= 1.0.301 =

* Modifies the revisions module. The current update increases the number of revisions per form to 20, where the older are removed from the database. Furthermore, it is possible to generate the revisions even pressing the preview button.

= 1.0.300 =

* Improves the code that creates the relationship between the fields' attributes and other fields in the form, furthermore, fixes some issues between this relationships and the dependencies.

= 1.0.299 =

* Modifies the Number and Currency controls allowing enter the name of other fields as the MAX and MIN attributes to define a relationship between the fields.

= 1.0.298 =

* Fixes an issue applying the stringify to the JSON object of form's structure.

= 1.0.297 =

* Includes the integration  with an advanced equations editor.

= 1.0.296 =

* Modifies the template 11 to fix a conflict with the Mega Addons For WPBakery Page Builder.

= 1.0.295 =

* Edits some styles that were redefined by the website's themes, breaking the forms' structures.
* Optimizes other styles defined in the plugin.
* Prevents that some files, required only by Elementor in the edition context, be loaded in the public website.
* Includes the new attribute in_tag (whose accepted values are: img or a) to be used with the special fields' tags <%fieldname#_url%> and <%fieldname#_urls%> into the notification emails and thank you pages, to include images tags or anchors to the uploaded files (Professional, Developer and Platinum versions of the plugin).

= 1.0.294 =

* Modifies the Upload File control for showing a preview of selected files before upload them.

= 1.0.293 =

* Modifies the module that evaluates the equations to fix a conflict with forms created by other plugins.

= 1.0.292 =

* Modifies all predefined templates and the forms' styles improving them and fixing some conflicts.
* Fixes some typos.
* If the thank you page is not defined, the user is redirected to the website's home page after submit the form (Professional, Developer and Platinum versions of the plugin)
* If the text of the notification email is empty, the plugin sends a summary of the information collected by the form (Professional, Developer and Platinum versions of the plugin)
* Improves the module that determines the default emails addresses for the From and Destination attributes in the form's settings (Professional, Developer and Platinum versions of the plugin)
* Improves the appearance of the PayPal Pro fields (Platinum version of the plugin)

= 1.0.291 =

* Removes some deprecated functions from the PHP 7.2

= 1.0.290 =

* Modifies the dependencies (Checkbox, Radio Buttons, DropDown, Container fields, Calculated fields).
* Modifies the date/time control for defining the aria-labels for screen readers.
* Fixes an issue that causes the loopback request to the site fails, caused by the sessions management (Professional, Developer and Platinum versions of the plugin).
* Includes a new attribute in the troubleshoot section for starting the session as soon as possible (in case of conflict with other plugins) (Professional, Developer, and Platinum versions of the plugin).
* Modifies the PayPal Pro add-on (Platinum version of the plugin).

= 1.0.289 =

* Improves the Widgets for Page Builder by SiteOrigin.
* Improves the Widgets for Elementor.
* Includes a new block for inserting the results list shortcode in the Gutenberg editor (Professional, Developer and Platinum versions of the plugin).
* Includes a new icon for inserting the results list shortcode in the Classic WordPress editor (Professional, Developer and Platinum versions of the plugin).
* Modifies the module that generates the default email address used in the "from" attribute (Professional, Developer and Platinum versions of the plugin).
* Fixes some errors in the CFF - CSV Generator add-on (Platinum version of the plugin).

= 1.0.288 =

* Implements new Widgets to allow the specific integration with the Page Builder by SiteOrigin.
* Improves the integration with the other pages builders.
* Modifies the Appearance/Widget, allowing to associate a class name to the form, and pass to it additional attributes (Professional, Developer and Platinum versions of the plugin).
* Includes minimum changes in the CFF - WooCommerce add-on (Developer and Platinum versions of the plugin).

= 1.0.287 =

* Fixes an issue that causes the loopback request to the site fails.

= 1.0.286 =

* Modifies the blocks for the Gutenberg editor,  preparing the plugin for WordPress 5.1

= 1.0.285 =

* Fixes an issue in the date/time controls.

= 1.0.284 =

* Fixes some issues in the slider control.
* Modifies the Date controls allowing to enter other fields' names as the min and max attributes.
* Modifies the Captcha generator to fix a conflict with other plugins.
* Includes some minimal changes in the DS fields (Developer and Platinum versions of the plugin).
* Includes some minimal changes in the interface of the Users Permissions add-on. Assings class names to the different tags in the list of users submissions (Developer and Platinum versions of the plugin).
* Modifies the CSV Generator add-on to improve the security in the generated CSV files.

= 1.0.283 =

* Modifies the code that assigns the default values to the slider control.

= 1.0.282 =

* Fixes an issue in the slider controls.

= 1.0.281 =

* Fixes a conflict with older browsers.
* Modifies the SESSION Management module.
* Includes a new module for cleaning the expired transients.
* The Platinum version of the plugin includes the CSV Generator add-on.

= 1.0.280 =

* Modifies the slider controls allowing to integrate other fields in the form with the attributes: min, max and step, and vary them dynamically at runtime.
* Modifies the predefined template 12 to display the down arrow in the DropDown fields.
* Allows to include the tags of the Section Break controls in the notification emails and thank you pages (Professional, Developer and Platinum verisons of the plugin)

= 1.0.279 =

* Fixes an issue with the tooltips defined in the radio buttons and checkbox controls.

= 1.0.278 =

* Modifies the module that generates the forms' previews, and the AMP versions of forms.
* Implements the specific integration with the Elementor pages builder.
* Improves the forms appearance in small screens.

= 1.0.277 =

* Improves the some of predefined templates.
* Optimizes the form's styles.
* Allows to includes images and html tags in the tooltips.
* Fixes an issue printing the list of messages when includes images (Professional, Developer, and Platinum versions of the plugin)

= 1.0.276 =

* Implements a new columns system to format the forms easier.

= 1.0.275 =

* Includes new operations: RADIANS to convert an angle in degrees to radians, DEGREES to convert a number in radians to degrees, ATANH to get the hyperbolic arctangent of a number.
* Includes new controls in the interface of the equations edition: SIN, COS, TAN, ASIN, ACOS, ATAN, ATAN2, ATANH, RADIANS, DEGREES.

= 1.0.274 =

* Modifies the blocks dimensions.
* Fixes an issue editing the additional attributes.
* Includes the Form ID in the submissions list.

= 1.0.273 =

* Improves the integration with the Gutenberg editor.

= 1.0.272 =

* Modifies the nonces to increase the plugin's security.
* Fixes some little issues with the messages list.

= 1.0.271 =

* Fixes an issue between the Promote Banner and the official distribution of WP5.0

= 1.0.270 =

* Includes new validations to prevent conflicts with wp-cron.
* Modifies the location of fields handler in the forms builder for dragging the fields easier.
* Modifies the styles in the public forms for fixing a conflict with some themes when the fields are distributed in columns.

= 1.0.269 =

* Fixes an issue managing the sessions.

= 1.0.268 =

* Modifies the management of sessions.
* Modifies the use of nonces and captcha.

= 1.0.267 =

* Fixes an issue in the PREC operation.

= 1.0.266 =

* Modifies the PREC operation.
* Modifies the rounding operations: ROUND, FLOOR, CEIL.
* Fixes an issue calculating the seconds in the DATEDIFF operation in the DATE/TIME operations module (Developer and Platinum versions of the plugin)

= 1.0.265 =

* Fixes an issue with the thousands separator in the number fields.

= 1.0.264 =

* Packs the getField operation into new operations module to be inserted directly from the equations editor.

= 1.0.263 =

* Fixes another conflict with the Speed Booster Pack plugin.
* Includes a new operation to access easier to the fields, for example to assign a value to the slider field: fieldname1, enter as part of the equation getField(1).setVal(50);

= 1.0.262 =

* Fixes a conflict with the new version of Gutenberg.

= 1.0.261 =

* Allows read the raw values of every field in the form.
* Fixes a conflict with some themes that apply a max-width css rule to the form's fields.
* Fixes a conflict with the Speed Booster Pack plugin.

= 1.0.260 =

* Fixes an issue in the controls: radio button, checkbox and dropdown.

= 1.0.259 =

* Fixes an issue in the date/time fields that allows select by default an invalid time.
* Suppports other plugins for managing the AMP versions of pages.
* Includes other minor changes.
* Modifies the iCal add-on (Platinum version of plugin)
* Includes the PrintFriendly add-on (Platinum version of plugin)

= 1.0.258 =

* Allows to use the Acceptance fields into the equations.
* Modifies the selector to the tag with the price of the product to replace in the CFF - WooCommerce add-on (Developer and Platinum versions of the plugin)
* Allows to use other special constants like: submissiondate_mmddyyyy, submissiondate_ddmmyyyy, and ipaddress, in the integration with WebHooks URLs (Developer and Platinum versions of the plugin) and the WebMerge add-on (the Platinum version of the plugin).

= 1.0.257 =

* Modifies the date/time field doing the time components more coherents, and fixes an issue in the field's validation. Applies the styles for errors to the time components.
* Applies different class names to the different components in the slider fields to take total control to their visual appearance.
* Categorizes the add-ons for grouping them in the settings page of the plugin (Developer and Platinum versions of the plugin).

= 1.0.256 =

* Fixes an issue with Date/Time fields in multi-pages forms. In multi-pages forms if the date/time field is the first one in the page, the datepicker dialog was displayed by default, now this behavior has been solved.
* Includes the Autocomplete Places add-on, alternative to the Google Places add-on but using the Photon API (Distributed with the Platinum version of the plugin)

= 1.0.255 =

* Fixes an issue with No Cents attribute in the currency fields.

= 1.0.254 =

* Fixes an issue with the values of the checkbox fields when its used the modifier |r in the equations.
* Fixes an issue in the tags replacements in the thank you pages and notifiation emails (Professional, Developer and Platinum versions)

= 1.0.253 =

* Modifies the currency fields to allow configure them for accepting only the whole part of value and for disabling the cents.
* Modifies the template 11.
* Allows to include the Instruct. Text fields in the thank you pages and notification emails (Professional, Developer and Platinum versions of the plugin).

= 1.0.252 =

* Fixes an issue in the public forms when the general texts are entered with apostrophes, escaping them.
* Includes new actions and filters.
* Modifies the code of the plugin to prevent an issue caused with a bug in the isNumeric method of jQuery, present in previous versions of the framework that are still used in many distributions of WordPress.
* Fixes an issue with the block tags in the notification emails and thank you pages when are associated to DropDown fields configured as multi-select (Professional, Developer and Platinum versions of the plugin).

= 1.0.251 =

* Modifies the Date/Time control to allow the use of other date formats, as well as the symbol to use as separator between the dates' components.
* Fixes an issue with the paddings in the Template 11.
* Modifies the WooCommerce add-on in the Developer and Platinum versions of the plugin, to include a pair of javascript variables with global scope: woocommerce_cpcff_product and woocommerce_cpcff_product_price for the product's id and price, respectively.

= 1.0.250 =

* Hides the promotion banner for the majority of roles and fixes a conflict between the promotion banner and the Gutenberg editor.
* Modifies the PayPal Pro add-on (Platinum version of the plugin)

= 1.0.249 =

* Fixes an issue in the AMP pages when the AMP Takeover option is enabled in the AMPforWP plugin.
* Fixes an issue in the MailChimp add-on allowing to access to more than 10 lists in Mailchimp (Platinum version of the plugin).

= 1.0.248 =

* Modifies the integration with the Guetenberg editor, replacing the deprecated methods with the new ones.
* Includes a new attribute in the PayPal settings for prompting (or not) the buyer's shipping address.

= 1.0.247 =

* Manages the browser's history to allow moving between the different pages of the multi-pages forms with the next/back buttons on the browser.
* Modifies the WooCommerce add-on (in the Developer and Platinum versions of the plugin) to pre-fill the fields in the form for the weight, length, width and heigth of product.

= 1.0.246 =

* Improves the drag and drop of fields into the forms builder.
* Allows create dependencies with the Section Break controls.
* Removes obsolete texts from the interface of plugin.
* Improves the Users Permissions add-on distributed with the Developer and Platinum versions of the plugin.
* Modifies the data-source controls in the Developer and Platinum versions of the plugin, implementing the connection to databases using PDO, allowing to read the data from multiple database engines, like: MySQL, Postgresql, MSSQL Server, SQLite, and many others.

= 1.0.245 =

* Modifies the currency and number controls to not apply the format to the default values when corresponding the checkbox is unticked.
* Solves some issues with the dependencies.
* Solves some accessibility issues, like labels without 'for' attributes or multiple elements with the same id.

= 1.0.244 =

* Fixes an issue with themes that include Bootstrap.
* Fixes an issue with the forms' previews when the classic option is selected for loading the plugin's resources.

= 1.0.243 =

* Modifies the Summary control to solve an issue when are left the fields in blank.
* Modifies the AMP versions of forms, and forms' previews to solve an issue with other plugins and themes like DIVI.

= 1.0.242 =

* Fixes an issue with a column in the plugin's database.

= 1.0.241 =

* Fixes an issue in the equations, when the values of fields include backslash symbols.

= 1.0.240 =

* Includes a new attribute in Radio Buttons and Radio Buttons DS fields to allow tick/untick the choices (similar to the checkboxes), or preserve the radio buttons default behavior.
* The plugin tries to extract numbers from the fields values to be used in the equations. This update allows to use a modifier with the fields' names in the equations to use the fields' values without processing. Ex: fieldname1|r (|r for raw)

= 1.0.239 =

* Removes some notices generated in the use of dbDelta function.
* Fixes another issue cloning the forms.

= 1.0.238 =

* Removes a notice when a form is cloned.

= 1.0.237 =

* Modifies the create table queries in the plugin's core and add-ons to reduce and optimize the database's queries.
* Fixes a little issue with the currency and number fields that not allows clear the fields' values.
* Fixes an issue with the attribute: if_value_is_not in the fields' tags of notification emails and thank you pages.

= 1.0.236 =

* Prevents possible conflicts with other plugins in the forms preview.
* Allows edit the forms submissions from the Messages section (Professional, Developer and Platinum versions of the plugin).
* Supports nested shortcodes into the content of the shortcodes: [CP_CALCULATED_FIELDS_RESULT] and [CP_CALCULATED_FIELDS_RESULT_LIST] (Professional, Developer and Platinum versions of the plugin).
* Modifies the Signature add-on, allowing to load the signature fields in the forms preview, and fixes an issue displaying the signature images in the messages section (Platinum version).

= 1.0.235 =

* Modifies the operations: ROUND, CEIL and FLOOR for accepting a second parameter (optional) and rounding the number in multiples of second parameter.
* Modifies the appearance of the forms builder settings in the free version of the plugin.
* The fields' tags to insert into the results shortcodes (paid versions of the plugin) accept a new set of attributes for taking more control about how and whe to include the fields (if_value_is_greater_than, if_value_is_greater_than_or_equal_to, if_value_is_less_than, if_value_is_less_than_or_equal_to, if_value_is, if_value_is_not, if_value_like and if_value_unlike)

= 1.0.234 =

* Modifies the code to be compatible with older versions of PHP.

= 1.0.233 =

* Fixes an issue generating the revisions table.

= 1.0.232 =

* Includes the revisions module to create different revisions of the forms when they are updated.
* Modifies the code that generates the forms to prevent that uncaugth javascript errors in the webpage affect the forms.

= 1.0.231 =

* Fixes an issue in the fields validation.

= 1.0.230 =

* Validates the values in currency fields.
* Improves the validations in the other controls.
* Improves the code to load the forms in the AMP pages.

= 1.0.229 =

* Fixes an issue with dependencies.

= 1.0.228 =

* Modifies the way that the forms builder is loaded to prevent that uncaugth javascript errors can affect it.
* Allows to define a new attribute in the forms shortcode to define the duration of the tooltips on mobiles devices. For example: [CP_CALCULATED_FIELDS id="1" tooltip_duration="10000"], in mobiles devices the tooltip will be displayed for 10 seconds, and then, it will be hidden. The number is defined in milliseconds 10000 is the equivalent to 10 seconds.
* Displays a gif animated when the form is being submitted to allow the users know that it is being processed (Professional, Developer and Platinum versions)

= 1.0.227 =

* Fixes an issue with the dependencies.
* Fixes an issue with the filtering conditions in RecordSet fields (Developer and Platinum versions of the plugin).

= 1.0.226 =

* Includes two new options in the Form Settings tab for controlling when the equations are evaluated, with the onchage events, or with the onchange and keyup events (the new options give more control over the form's performance).
* Includes the form's id and name in the Forms Builder to facilitate identify the form.
* Allows to configure the form to not capture the users' ip addresses (Professional, Developer and Platinum versions).
* Fixes an issue accepting .rar files with the Uploads add-on(Platinum version).
* Allows to select groups by default in the MailChimp add-on(Platinum version).

= 1.0.225 =

* Fixes an issue in the definition of dependencies in the calculated fields.

= 1.0.224 =

* Modifies the size of the container fields to improve dragging fields into the containers.
* Fixes an issue with the validation rules in the non-visible fields (fields into hidden containers).
* Includes a new special attribute in the form's shortcode (class), to assign class names to the forms.
* Dissables the submit button when it is pressed to prevent the form be submitted multiple times (Professional, Developer and Platinum versions).
* Fixes an issue with the Widgets (Professional, Developer and Platinum versions).
* Fixes an issue checking if the nonce that protects the public form is active or not (Professional, Developer and Platinum versions).
* Modifies the way that the cp_calculatedfieldsf_insert_in_database.php file is included, to allow include in the $params array the itemnumber, that represents the submission's id (Developer and Platinum versions).

= 1.0.223 =

* Modifies the default title in the Acceptance control.

= 1.0.222 =

* Includes the Acceptance (GDPR) control for inserting a required checkbox field in the form for asking the users their consent to store and use the information provided.

= 1.0.221 =

* Modifies the Next Page and Previous Page buttons to respond to the keys: space and enter, and to be selected with the tab key.
* Modifies the Checkbox fields to return the original values of the choices selected (without parsing the numbers) when is unticked the attribute for merging the values.
* Modifies the parseValStr function in the fbuilder-pro-public.jquery.js file.
* Modifies the Submit button to respond to the keys: space and enter, and to be selected with the tab key (Professional, Developer and Platinum versions of the plugin).
* Modifies special tag <%fieldname#_urls%> used in the notification emails, and thank you pages, to display each URL in its own line (Professional, Developer and Platinum versions)
* Displays an error message in the form when the coupon is checkes and it is invalid (Professional, Developer and Platinum versions)
* Fixes an issue in the link to the forms' events from the dashboard page (Professional, Developer and Platinum versions)
* Implements the special tags: <%fieldname#_nonblock%><%fieldname#_endnonblock%> to include a block of content if the fieldname# field has not being submitted or it was submitted in blank (Professional, Developer and Platinum versions)

= 1.0.220 =

* Modifies the dependencies in radio buttons, checkboxes, drop-down fields, containers and calculated fields.
* Modifies the htmlEncode function in the fbuilder-pro-admin.jquery.js file.
* Fixes an issue with the changes of lines in the exported CSV files with the submissions (Professional, Developer and Platinum versions)
* Allow to exlude the attachments from the notification emails (Professional, Developer and Platinum versions)
* Fixes an issue in the special tags <%fieldname#_urls%> and <%fieldname#_links%> used in the notification emails, and thank you pages (Professional, Developer and Platinum versions)
* In the WooCommerce add-on includes a new hidden tag named woocommerce_cpcff_product_price with the base price of the WooCommerce product (Developer and Platinum versions)
* In the MailChimp add-on allows to select the status of new users, between pending and subscribed (Platinum version)

= 1.0.219 =

* Fixes a conflict with the latest update of the 'Accelerated Mobile Pages' plugin.

= 1.0.218 =

* Fixes an issue with the loopback requests when are being edited the code of plugins or themes in the WordPress editor.

= 1.0.217 =

* Includes a new attribute in some fields to convert them in read only.

= 1.0.216 =

* Fixes an issue with plugin installation in multisite WordPress.
* Fixes an issue with Radio Button DS and Checkbox DS fields in the Developer and Platinum versions of the plugin.
* Includes the Server Side Equations Add-On in the Developer and Platinum versions of the plugin.

= 1.0.215 =

* Modifies the radio button control.
* In the Developer and Platinum versions of the plugin modifies the access to the CSV files when they are hosted in secure websites.

= 1.0.214 =

* Fixes an issue in the module that removes the eq_factored attributes fields.

= 1.0.213 =

* Fixes an issue with the dependencies in the radio buttons fields.
* Fixes a conflict with the styles of the template 12 and some WordPress themes.
* Removes the eq_factored attributes (used in previous versions of the plugin) from the calculated fields.

= 1.0.212 =

* Fixes an issue determining the values of DropDown and DropDown DS fields.

= 1.0.211 =

* Generates the cached javascript file from the settings page of the plugin.
* Modifies the DropDown and Checkbox controls to allow return their values as an array (the values of choices selected or ticked) or the sum or concatenation of them.
* In the Developer and Platinum versions of the plugin were modified the DropDown DS and Checkbox DS controls.
* In the Developer and Platinum versions of the plugin were modified the operations in the Financial module to return the values without rounding.
* In the Professional, Developer and Platinum versions of the plugin was included the [CP_CALCULATED_FIELDS_RESULT_LIST] shortcode to display the list of summaries corresponding to a form.

= 1.0.210 =

* Fixes an issue in the DropDown controls when the multiple choices selection is enabled.

= 1.0.209 =

* Modifies DropDown control to allow multiple selection and to define the control size (the same behavior was implemented in the DropDown DS control in the Developer and Platinum versions of the plugin).
* Modifies the Radio Button control to allow tick/untick a choice (the same behavior was implemented in the Radio Button DS control).
* Modifies the Checkbox control to allow define a maximum number of checkable choices, and the error message if are exceeded the number of ticked choices (the same behavior was implemented in the Checkbox DS control in the Developer and Platinum versions of the plugin).
* Modifies the promotion banner.

= 1.0.208 =

* Modifies the copy of the jquery.validate for fixing some conflicts with third party plugins.

= 1.0.207 =

* Updates the latest version of jquery.validate in the plugin.
* Improves the validation rules in the "Single Line Text" and "Upload Files" controls.
* Converts the "type" attribute of email controls into email.

= 1.0.206 =

* Fixes a minor error, the "cff-radiobutton-field' class had been assigned at level of choices containers, and not at level of field's container as the other controls.

= 1.0.205 =

* Fixes some warnings when the forms' shortcodes are inserted without the id attributes.
* The Platinum version includes the Twilio add-on to integrate the forms with the Twilio service and sending notification SMS when the forms are submitted.

= 1.0.204 =

* Shows the fields' names (fieldname#) as tooltips of the fields inserted in the form (into the forms builder) to identify the fields easily in the equations' development.
* Includes some modifications in the Template 6.
* In the Professional, Developer and Platinum versions the plugin shown a message if the email used for registering the copy of the plugin is valid or not.
* Modifies the Stripe add-on in the Platinum version of the plugin.

= 1.0.203 =

* Fixes a conflict with Varnish in the free version of the plugin.
* Fixes an issue scrolling the webpage in the forms with multiple pages, when the pages don't have focusable elements.
* Modifies the DISTANCE operation in the Developer and Platinum versions.
* Modifies the following fields: DropDown DS, Checkbox DS, and RadioButton DS, in the Developer and Platinum versions of the plugin, to avoid duplicated choices.

= 1.0.202 =

* Fixes an issue with the session variables.
* Modifies the parameters of the cpcff_payment_processed action.

= 1.0.201 =

* Modifies the DropDown fields to include optgroup tags.
* Modifies the Date/Time fields.

= 1.0.200 =

* Improves the integration with the Gutenberg Editor.

= 1.0.199 =

* Allows the integration with the Gutenberg Editor, the next editor for WordPress (Includes new blocks for inserting the corresponding shortcodes).
* Replaces the icon for waiting in the AMP pages by a transparent icon.

= 1.0.198 =

* Removes the !important; declaration from the CSS rule into the pair of tags <style amp-custom></style> to satisfy the AMP rules.

= 1.0.197 =

* Modifies the redirection of the amp-iframes tags, to increase the speed loading the forms in the AMP pages.
* For the Developer and Platinum versions of the plugin, modifies the reCAPTCHA add-on.

= 1.0.196 =

* Fixes an issue editing the URLs of the AMP pages.
* For the Professional, Developer and Platinum versions of the plugin, the submit button is disabled when pressed, to prevent the form be submitted multiple times.

= 1.0.195 =

* Modifies the summary control to remove all elements are not part of the fields' labels (as the * symbol for required fields and the date/time format). Furthermore, if the fields' labels were defined with colon symbols at the end, they are removed to prevent the colon symbols be displayed twice in the summary.
* In the paid versions of the plugin applies the same modifications to the summary displayed in the thank you page and the notification emails.

= 1.0.194 =

* Draws an AMP restriction with the iframe tags when the URL belongs to the same website.
* Solves a minor issue determining the public URL of the website.

= 1.0.193 =

* Fixes a minor issue with the forms in the AMP pages.

= 1.0.192 =

* Allows scrolling the forms in the AMP pages when are visited from iPhones and iPads.

= 1.0.191 =

* Fixes an issue with the AMP version of forms.

= 1.0.190 =

* Allows to display the forms in AMP pages. If the AMP plugin is installed in the website and the form is inserted into an AMP page, it is loaded into a iframe tag to satisfy the AMP requirements.

= 1.0.189 =

* Allows to start the phone fields with the plus symbol (+) for international numbers.
* Fixes some notices.
* Reduces the number of database queries.
* Optimizes the plugin's code.

= 1.0.188 =

* Fixes an issue with the forms' preview in some WordPress configurations.
* The free version of the plugin solves a conflict with Varnish.
* The Developer and Platinum versions fixes some issues with external datasources.

= 1.0.187 =

* Fixes an issue formatting dynamically the values on number and currency fields.
* Modifies the server side scripts that generate the client side scripts to prevent issues with notices and warnings not related with our plugin.
* Modifies the WebHook add-on (for the Developer and Platinum versions of the plugin) to allow decide if sending the data to the webhook before or after receive the payments confirmations.
* Modifies the WooCommerce add-on (for the Developer and Platinum versions of the plugin) to allow define the selector of the price's tag in the products pages to update the visual price at runtime.

= 1.0.186 =

* Fixes an issue with the message after cloning a form.

= 1.0.185 =

* Fixes an issue with the access to the external links in the submenu of the plugin.

= 1.0.184 =

* Reduces the number of queries to database.
* For the Professional version of the plugin, modifies the module to export the forms.
* For the Developer version of the plugin, modifies the "DS" set of fields, and improves the security of database accesses.
* For the Platinum version of the plugin, fixes a notice in the MailChimp add-on.

= 1.0.183 =

* Modifies the database's structure to prevent issues with a wrong character set in the columns.

= 1.0.182 =

* Improves the access to the plugin's options.
* Fixes an issue in the CPCFF_FORM class.
* In the Professional version modifies the module that generates the content of the notification emails and thank you pages, including the special tags: <%subscription_id%> to display the id of subscription for recurrent payments, and the <%couponcode%> to include only the coupon's code without the discount message.
* In the Developer version fixes an issue in the WooCommerce add-on for displaying the summary of collected data in the shopping cart page and the orders.
* In the Platinum version fixes some issues in the payment gateway add-ons.

= 1.0.181 =

* Fixes the URLs to the demo, help, and upgrade pages.
* Modifies the module for the forms preview.

= 1.0.180 =

* Reduces the number of database queries.
* Adds new validation rules in the data received, increasing the security.
* Improves the performance and the plugin's code.

= 1.0.179 =

* Includes some changes in the forms' settings.

= 1.0.178 =

* Allows to insert the forms' shortcodes directly into the Text Widgets on sidebars.
* Improves the plugin's code and the forms' perfomance.
* In the Professional, Developer, and Platinum versions of the plugin improves the validation of the uploaded files, and the management of coupons.

= 1.0.177 =

* Includes the integration with the CP Blocks plugin.
* Fixes an issue in the Emma add-on distributed with the Platinum version of the plugin.

= 1.0.176 =

* Modifies the currency fields formatting the entered values always with the decimal places.
* Optimizes the code to strips the slashes from the submitted values.
* Fixes some warnings in the script for external data-sources integration in the Developer and Platinum versions of the plugin.

= 1.0.175 =

* Modifies the module to load the forms' templates, and the module that creates the javascript variables, improving the plugin's perfomance and reducing the number of instructions.
* Fixes other minor errors.

= 1.0.174 =

* Improves the Template 8.
* Improves the appearance of the forms builder in mobiles devices.
* Fixes other minor errors.

= 1.0.173 =

* Modifies the radio buttons and checkbox controls.
* Improves the forms in websites with right-to-left direction.
* Improves the accessibility of the forms builder in mobiles devices.
* Solves a conflict between the AdBlocker extension in the browsers, and the Google Analytics add-on.
* Fixes other minor errors.

= 1.0.172 =

* Includes the "Enable the browser's persistence" option in the form's settings. This feature persists the data entered by the users locally in their browsers, so, if an user closes the browser's tab, when visit the form again the data would be there. The data persisted are deleted when the form is submitted.

= 1.0.171 =

* Improves the plugin performance, its code, and the code documentation.
* Solves some issues in the Signature and Google Place add-ons for the Platinum version.

= 1.0.170 =

* Includes the CPCFF_MAIN class for controlling and organize the plugin's code (actions and filters).
* Sends the specific Content-Type header with the scripts of controls.

= 1.0.169 =

* Modifies the code that parses the JSON strings.
* Includes the write_logs method for writing the execution errors in the PHP error logs file.

= 1.0.168 =

* Reduces the number of database queries in the installation and update process.
* Removes unnecessary constant.
* Moves the installation code to its own file.

= 1.0.167 =

* New modifications in the optimization process that reduces the number of database queries, and improves the code.

= 1.0.166 =

* Increases the size of the "ipaddr" column in the database.

= 1.0.165 =

* Checks the dependencies associated to the calculated fields, even if the dynamic evaluation of the equations is disabled.
* Increases the sizes of textarea fields for entering the equations in the calculated fields, and the HTML code in the HTML Content fields.
* The Professional, Developer, and Platinum versions of the plugin accept the formid attribute in the [cp_calculatedfieldsf_form_result] shortcodes to allow the coexistence of multiple shortcodes for different forms in a same thank you page.

= 1.0.164 =

* Includes a new option in the "Form Settings" tab to customize the forms' designs.
* Makes all textareas controls, in the fields properties, vertically resizable to facilitate to enter the data.
* Allows to expand the controls and properties bars.
* Modifies the fields' attributes to adjust them to the new dimensions of the properties bar when it is expanded.

= 1.0.163 =

* Regroup the plugin's code as the first step in the optimization process.

= 1.0.162 =

* Modifies the javascript code to allow the integration with the CP Blocks plugin.

= 1.0.161 =

* Removes all unnecessary eval instructions to improves the forms' performance, and increase the security.

= 1.0.160 =

* Modifies the controls: checkbox, radio buttons, and dropdown to remove a code for compatibility with very outdated versions of the plugin.
* Removes the JSON class, included only for supporting PHP versions lesser than 5.2.x

= 1.0.159 =

* Loads the "HTML Content" fields at 100% of the form's width even if the labels are aligned at left or right.
* Allows to apply automatically the format defined in the numbers fields to the values entered by the users (Similar to the currency fields).

= 1.0.158 =

* Checks the PHP version before applying some functions that were included in PHP versions higher than v5.2.+

= 1.0.157 =

* Fixes an issue in the promote banner.

= 1.0.156 =

* Modifies some styles in the predefined templates.

= 1.0.155 =

* Modifies the module for accessing the WordPress reviews section.

= 1.0.154 =

* Fixes an issue in the validation of the number fields for accepting numbers in scientific (exponential) notation.

= 1.0.153 =

* Modifies the URLs of the admin section.
* Modifies the parameters of the json_encode function.

= 1.0.152 =

* Allows collapse/uncollapse the container fields in the administration section.

= 1.0.151 =

* Modifies the dependencies in the calculated fields.
* Modifies the module that parses the values.
* Fixes an issue with the error messages when the fields labels are aligned at left or right.

= 1.0.150 =

* Modifies the module that parses the values used by the equations.
* Professional Version: validates the required input fields in the server side.
* Developer Version: modifies the WooCommerce add-on, making it compatible with WooCommerce 3.x
* Platinum Version: improves the texts management in the payment gateways add-ons.

= 1.0.149 =

* Adds a new predefined template.
* Adds specific class names to the fields, to allow modify their appearance easier.
* Modifies the submenu options to facilitate the access to the documentation.

= 1.0.148 =

* Fixes an issue in the CDATE operation for dates before 1/1/1970.
* Fixes an issue with the placeholder attribute of textarea fields in multi-pages forms.
* Fixes an issue with the Radio Button DS, and Checkbox DS fields and the validation rule for required fields in multi-pages forms.

= 1.0.147 =

* Modifies the calculated fields for checking the dependencies the first time the equations are evaluated the first time, even if was not triggered an onchange event.

= 1.0.146 =

* Modifies the predefined templates and change their titles to make them more coherent.
* Adds a new template.
* Modifies the phone and container controls.

= 1.0.145 =

* Modifies the interface of the forms settings.

= 1.0.144 =

* Prevents to load some of the plugin's resources by duplicated.

= 1.0.142 =

* Includes a new hook, an action when a form is deleted: cpcff_delete_form, passing as parameter the form's id
* Fixes an issue when the user includes a the form's shortcode with the id of an inexistent form, or without any id.
* Fixes an issue with the sliders on mobiles when the script load method is configured as direct.

= 1.0.141 =

* Solves a notice message in the process of saving the form's structure in the database (when the form has a specific structure).
* Includes some little changes in the forms builder.

= 1.0.140 =

* Modifies the setVal method in the controls: checkboxes, radio buttons, and dropdown.
* Modifies the module that evaluates the equations to prevent some infinite loops generatedby the users.
* Homogenizes the events of controls in the administration section.

= 1.0.139 =

* Modifies the pagination module for scrolling to the beginning of page only if needed.
* Includes the __ME__ constant for referring in the equations to the value of the calculated field that is being calculated.

= 1.0.138 =

* Modifies the controls: Checkbox, Radio Buttons, and DropDown to allow the users decide the information to submit (the value or the text of choices selected).
* Fixes an issue with the ampersand symbols in the default values of fields.
* Increases the size of database's columns for email addresses(Affects the Professional, Developer, and Platinum versions of the plugin).
* Modifies the "Users Permissions" add-on to allow filtering by the form's id (Affects the Developer and Platinum versions of the plugin).

= 1.0.137 =

* Modifies the module that loads the templates.
* Fixes a warning message, related with the PHP Headers when there are used plugins for managing website's cache.

= 1.0.136 =

* Fixes an issue with the dependencies and the phones fields.
* Fixes an issue loading the default values of fields, defined with javascript.

= 1.0.135 =

* Allows to define validation rules in the Single Line Text fields using regular expressions.
* Allows to disable the choice selected by default in Radio Buttons and DropDown fields.
* Modifies the module that loads the forms templates to include the resources only one time in the webpage.
* Increases the value of the css rule: z-index applied to the datepicker to fixes the overlapping with the error messages.
* Creates the database tables with UTF-8 as the character encoding, to support Cyrillic characters by default (in the previous versions of the plugin, if the character encoding of website's database is not UTF-8, for supporting Cyrillic characters, would be required modify the character encoding from the troubleshoot section in the settings page of the plugin)

= 1.0.134 =

* Fixes an issue with the escaped quotes and double quotes.
* Improves the code for ticking and selecting the choices in radio buttons, checkboxes, and DropDown.

= 1.0.133 =

* Allows to define and display left and rigth captions for the slider fields.
* Improves the sessions management.
* The DropDown DS, Checkbox DS, and Radio Buttons DS fields allow to define the options to select by default.

= 1.0.132 =

* Includes an alternative method to load the resources required by the forms builder.

= 1.0.131 =

* Includes a new character encoding option for supporting utf8mb4 characters.
* Includes new menu options to facilitate the access to the plugin documentation.

= 1.0.130 =

* Fixes an issue in the styles related with the container controls in the forms builder.

= 1.0.129 =

* Improves the performance of the forms builder module (More palpable in forms with large number of fields).

= 1.0.128 =

* Convert single line comments in the javascript code, into multiple lines comments to prevent conflicts with plugins that minify the pages code.

= 1.0.127 =

* Fixes a vulnerability in the module that modifies the database character encoding. Thank you to the National Cyber Security Centre (NCSC-NL) for detecting and help in correct this vulnerability.

= 1.0.126 =

* Allows to define the error messages for the invalid files extensions, and files sizes, associated to the File Upload controls, from the form's settings.

= 1.0.125 =

* Fixes some characters that break the JSON structure of forms.
* Optimizes the code of controls.

= 1.0.124 =

* Removes the "BOM" characters from the form's structure.
* Fixes an issue with the "Upload Files" field when the option of multiple files is selected.
* Increases the size of some columns in the database for forms with many many fields.

= 1.0.123 =

* Modifies the management of checkbox values.

= 1.0.122 =

* Replaces the H1 tags in the forms headers with H2 tags by recommendation of Goolge. The modification includes changes in the predefined templates and the scripts.
* Has been removed the deprecated parameter "signed_in" from the distance module (integrated with Google Maps) in the versions Developer and Platinum of the plugin.

= 1.0.121 =

* New changes in the module that manages the sessions and cookies to prevent conflict with other plugins of sessions management.

= 1.0.120 =

* Modifies the module to get the values of textual controls (single line text, textarea, phone, email, password) solving a coherence issue between numeric and textual fields.

= 1.0.119 =

* Improves the management of cookies and sessions.
* Fixes an issue dragging sections separators into containers.

= 1.0.118 =

* Fixes an issue loading public resources.

= 1.0.117 =

* Fixes an issue loading admin resources.

= 1.0.116 =

* Fixes an issue in the module to prevent the use of sessions.

= 1.0.115 =

* Fixes an issue in the code to remove fields from the form.
* Prevents the use of session variables.

= 1.0.114 =

* Fixes an issue in the module to duplicate fields.

= 1.0.113 =

* Allows hide the date part of the date/time fields.

= 1.0.112 =

* Modifies the module that encodes the attributes of the fields.

= 1.0.111 =

* Solves the conflict with Autoptimize

= 1.0.110 =

* New changes in the validation of the Date/Time controls.

= 1.0.109 =

* Modifies the Date/Time control to validate the field when the hours or minutes are modified.
* Uses session variables to identify the resources to load and prevent conflicts with other plugins.
* Modifies the action of the form to submit the form to the same page.

= 1.0.108 =

* Replaces the class constructors in the third party code used by the plugin, to the new standard: __construct

= 1.0.107 =

* Modifies the interface of the forms settings.
* In forms with multiple pages after pressing the next and previous buttons, the page is scrolled to the top of the form page.

= 1.0.106 =

* Modifies the date time control.
* Validates the form's structure before be stored into database to prevent saving corrupted data.
* Escapes the values of the fields' attributes.

= 1.0.105 =

* Closes dynamically the tooltips in mobiles devices after a timeout.
* Scroll the browser to the first focusable field, after pressing the buttons: "next page" and "previous page", to solve an issue with iPhones mobiles.
* Allows modify the messages for the errors: "Equal To", "Min length/characters", and "Max length/characters"

= 1.0.104 =

* Modifies some of the predefined templates.
* Fixes a possible conflict between the tooltips styles, and the themes.

= 1.0.103 =

* The feature: optimize equations, is not needed after the last improvements, the current version removes this option.

= 1.0.102 =

* New change in the Date/Time fields.

= 1.0.101 =

* Corrects an issue with the Date/Time Fields.

= 1.0.100 =

* Corrects an issue in the Containers and Phone fields.

= 1.0.99 =

* Optimizes the dependencies with containers fields.

= 1.0.98 =

* Optimizes the equations and dependencies. Corrects some issues in the templates: "Clean Design" and "Minimalist Form".

= 1.0.97 =

* New changes in the equations.

= 1.0.96 =

* Optimizes the equations, and their evaluations.

= 1.0.95 =

* Allows duplicate container fields (DIV and Fieldset).

= 1.0.94 =

* Includes some changes in the "Date/Time" fields, and with the type of data in the Equations to allow the use of records.

= 1.0.93 =

* Sets the focus in the first focusable element of a multi pages form.

= 1.0.92 =

* Remove all unnecessary fields from the operands list in the equations editor of the Calculated Fields.

= 1.0.91 =

* Set the attribute: "Script load method" to "Direct" by default, because many of themes in the market are not prepared for jQuery 1.12.3, and are generating syntax errors in the websites.

= 1.0.90 =

* Corrects an issue with the dragging and dropping of fields into the form.
* Corrects an issue with different levels of dependencies between fields.

= 1.0.89 =

* Partial update to correct some issues, until implementing the definitive solution.

= 1.0.88 =

* New modifications and optimizations.

= 1.0.87 =

* New modification in the dependency between fields.

= 1.0.86 =

* Corrects an issue in the fields dependencies.

= 1.0.85 =

* Modifies the code  in the CAPTCHA script, used for checking the sessions variables.

= 1.0.84 =

* Modifies the behavior of the slider control.

= 1.0.83 =

* Prevents the insertion of javascript code through the shortcode (thanks to i0-sec).

= 1.0.82 =

* Prevents to access to the Cookies classified as "httponly", through the shortcode: [CP_CALCULATED_FIELDS_VAR] (thanks to i0-sec).

= 1.0.81 =

* Modifies part of generated HTML to satisfy the standard.

= 1.0.80 =

* Prevents a possible conflict with other plugins that use jQuery Stringify.

= 1.0.79 =

* Modifies the Radio Button and Checkbox controls.

= 1.0.78 =

* Creates a new variable based on the additional attributes defined through the form shortcode, and allows to use a new constant in the equations, the form_identifier, with the value of the "cp_calculatedfieldsf_pform_psequence" tag, to identify each instance of the form in the same webpage.

= 1.0.77 =

* Allows to assign custom class names to the hidden fields.
* Modifies the CAPTCHA module, to fix a conflict with the backslash symbols in the files paths on Windows Servers, and some PHP functions as the imagettftext.

= 1.0.76 =
* Includes two new operations: The greatest common divisor between two numbers, and the logarithm of "number A" base "number B".
* The Distance module, in the Developer version of the plugin, includes the TRAVELTIME operation to get the time of traveling between two places.
* The Financial module, in the developer version of the plugin, includes the operations: IPMT, PPMT, PVIF, FVIFA, XNPV, and XIRR

= 1.0.75 =
* Fixes an issue with the position of error messages.

= 1.0.74 =
* Now it is possible to define ranges of invalid dates for date fields.
* The Upload Files control, displays the list of selected files, whether the multiple selection is enabled.
* Improves the validation rules in Upload Files control.
* Fixes the position of validation messages, to prevent overlapping with the controls.

= 1.0.73 =
* Simple update to increase the spaces between radio buttons and checkboxes distributed side by side.

= 1.0.72 =
* Modifies the loading of CSS files to fix an issue with multiple forms in a same page but with different templates.

= 1.0.71 =
* Removes the duplicate LINK tags in the public forms.
* The developer version includes improves the performance of DS fields, and includes a "Currency DS" control.

= 1.0.70 =
* Modifies the labels on Radio and Checkboxes fields.

= 1.0.69 =
* Modifies the labels on Radio and Checkboxes fields.

= 1.0.68 =
* Modifies the code of some controls to make the execution more consistent.
* Defines some filters and actions to allow the integration with third party plugins.
* Adds a new add-on in the developer version of the plugin.

= 1.0.67 =
* Validates the range of years on Date fields to prevent javascript errors.

= 1.0.66 =
* Allows the use of language files.

= 1.0.65 =
* Corrects an issue in the form settings.

= 1.0.64 =
* Modifies the shortcode: [CP_CALCULATED_FIELDS_VAR]
* Modifies the mode for loading the CSS files in the public website.

= 1.0.63 =
* Prevents an issue caused by the Minify options of "W3 Total Cache".
* Validates the fields in the "onblur" event.

= 1.0.62 =
* Modifies the summary control to display the caption of Slider controls.
* Corrects an issue in the reset action of forms with the slider and DateTime controls.

= 1.0.61 =
* Modifies the behavior of the Reset Button field. After reset the form, the dependencies are validated, and the user is redirected to the first page, if the button is inserted in a multi-page form.
* Validates the database structure, and displays a warning message if the database has not been updated.

= 1.0.60 =
* Corrects an issue in the radio buttons values.

= 1.0.59 =
* Corrects a conflict with the "Back-Forward Cache" in the Firefox browser.
* Modifies the values returned by the controls: "Single Line Text", "Radio", and "DropDown", to get more consistent results. In previous versions the plugin extracts the numbers included in the values of fields. In the current version, the values returned are the defined values on fields, or zero if the fields are empties.
* The add_shortcode functions were moved to the 'init' action.
* The developer version include the "Distance" module, that integrates the plugin with Google Maps, to get the distance between two addresses.

= 1.0.58 =
* Prevents that the script tags in the forms are modified by the wpautop function of WordPress.

= 1.0.57 =
* Improves the behavior of dependencies. Excluding fields like: section breaks and page breaks from dependencies.
* Modifies the styles in the predefined layouts.
* Allows to disable the forms when the website is visited by search engine spiders and crawlers, increasing the website's speed.
* Corrects an issue parsing the text values on fields.
* The pro and developer versions allows to store the forms in cache to increase the rendering speed. This feature will be included in the free version after be tested completely in the other versions of the plugin.
* Moves the checking of database's structure to the plugin activation process.

= 1.0.56 =
* Adds new parameters to the cached files to prevent issues with the browsers cache, after upgrade the plugin.

= 1.0.55 =
* Correct some issues in the optimizing process.
* Allows to use the HTML fields in dependencies.
* Modifies some of predefined layouts.

= 1.0.54 =
* Optimizes the plugin's code, reduces the accesses to database, and submits less information.

= 1.0.53 =
* New update for all predefined layouts.

= 1.0.52 =
* Optimize the predefined layouts.

= 1.0.51 =
* Corrects an issue determining the website's URL

= 1.0.50 =
* Corrects the type of input fields used by the "Number" controls. If the format of control is "digits", or if the thousands separator is empty and the decimal symbol is the dot symbol, the input field will use the attribute: type="number", and type="text" in other cases. In input fields with type="number", the mobiles devices activate their numeric keyboards.
* Modifies the "HTML Content" control, to removes the tags: <style> and <script> from the tags editor of the form's builder, to prevent these tags modify the appearance of the editor page. The tags are included in the public website.
* Modifies the "Button" control to allow the implementation of complex functions in the onclick event, and inserts the button disabled in the controls editor.
* Inserts the "File" control disabled in the controls editor.

= 1.0.49 =
* Adds the new control: HTML Content, to add html tags, and javascript code, directly on form.

= 1.0.48 =
* Prevents the insertion of "Page Break" fields into containers fields.
* Defines the text colors in the errors messages.

= 1.0.47 =
* Optimizes the loading of public resources, javascript and CSS files.

= 1.0.46 =
* Improves the Drag and Drop feature to reordering the fields on form.
* Replaces the <h2> tags by <h1>, following the WordPress developers suggestions.
* Uses the class constructors of PHP5

= 1.0.45 =
* Corrects the URLs schemes to guarantee the use of SSL.

= 1.0.44 =
* Fixes an issue parsing numbers.

= 1.0.43 =
* Improves the parsing of numbers to get correct values, even for numbers with invalid formats.

= 1.0.42 =
* Improves the checking of dependencies in the calculated fields.
* Improves the parsing of configuration files of the predefined templates.

= 1.0.41 =
* Prevents a possible issue generating the javascript files.

= 1.0.40 =
* Modifies the validation rules on Number, Currency, and Date/Time controls.

= 1.0.39 =
* Creates a minified version of the controls code, to increase the loading pages speed.

= 1.0.38 =
* Corrects an issue loading multiple forms in a same page.

= 1.0.37 =
* Corrects an issue with float numbers in the equations.

= 1.0.36 =
* Corrects an issue with float numbers in the equations.

= 1.0.35 =
* Improves the process for optimizing the equations.

= 1.0.34 =
* Adds a new predefined layout to the plugin, and modifies the existent.

= 1.0.33 =
* Corrects the location of the tooltips.

= 1.0.32 =
* Modifies all templates to adjust the slider control.

= 1.0.31 =
* Includes a new predefined Layout.

= 1.0.30 =
* Includes a new predefined Layout.

= 1.0.29 =
* The current update modifies the module for parsing numeric values, using the "." symbol as decimals separator in numbers, if the user leaves empty this attribute.

= 1.0.28 =
* Improves the design of the forms for printing.

= 1.0.27 =
* Corrects an issue with the hidden fields, that are displaying their labels when are inserted into a container field.

= 1.0.26 =
* Includes a new template.

= 1.0.25 =
* Modifies the insertion queries.

= 1.0.24 =
* Includes a validation text, for files bigger than size limit defined.

= 1.0.23 =
* Modifies the fields: summary, hidden, and calculated.

= 1.0.22 =
* Modifies the File fields for accepting multiple files in a same file tag.
* Includes new features in the Pro and Dev versions of plugin (http://blog.net-factor.com/xK6dJ)

= 1.0.21 =
* Corrects an issue loading the templates.

= 1.0.20 =
* Corrects an issue with the dependencies in the calculated fields, and where calculated fields are the dependent fields too.
* Sets the focus in the first invalid field, when the validation rules fail.

= 1.0.19 =
* Implements a new icon to insert a shortcode in the contents of pages and posts, to create JavaScript variables from GET, or POST parameters, SESSION variables, or COOKIES.

= 1.0.18 =
* Corrects a PHP notice, for a non initialized variable.

= 1.0.17 =
* Includes the "column" attribute in the container fields (DIV and FIELDSET) to display in columns the fields into the container.
* Improves the detection of the homepage's URL, for loading the resources.
* In the paid versions of the plugin, if WordPress uses SMTP for sending emails, then prevents to use the "phpmailer_init" actions.

= 1.0.16 =
* Modifies the validation rules for limiting infinite or NaN values, in numeric results.

= 1.0.15 =
* Modifies the validation rules for accepting textual values in the calculated fields.

= 1.0.14 =
* Hides the labels and the help for users, in the calculated fields configured as hidden from the public page, to prevent these fields are displayed if the calculated fields are dependent of a radio button, checkbox, or dropdown field, and the choice is selected.

= 1.0.13 =
* Modifies the styles associated to the forms.

= 1.0.12 =
* Increases the plugin's security, using the WordPress Nonces mechanism.
* Allows the installation of the plugin in a WordPress Multisite.

= 1.0.11 =
* Modifies the replacement of numbers in the equations to avoid invalid operations.
* Modifies the database queries to avoid some potential vulnerabilities.

= 1.0.10 =
* Modifies the slider control for accepting decimal numbers.

= 1.0.9 =
* Corrects some issues with the slider control, and enables the drag and drop feature of the slider in the mobile devices.

= 1.0.8 =
* Improves the behavior, and correct and issue with the following controls: date, checkbox, radio button group, and drop-down

= 1.0.7 =
* The current update add the slider control.

= 1.0.6 =
* The current update allows to define the time control as 12 or 24 hours.

= 1.0.5 =
* The fields defined as small or medium, are displayed large in small screens.
* Corrects a conflict with others of our plugins that use the form builder, when both plugins are inserted in the same page.

= 1.0.4 =
* Modifies the media control to insert multiple images in the same form.

= 1.0.3 =
* Modifies the loading process of the javascript files.
* Modifies some styles applied to the forms to improve the appearance of the forms in small screens, like mobiles and tablets.

= 1.0.2 =
* Corrects an issue with the placeholder attribute in the date/time fields
* The reset button clears the fields values in the summary fields
* Improves the performance of the calculated fields

= 1.0.1 =
* Compatibility issues fixed, faster loading
* New configuration settings
* Compatible with all the latest WP versions
* Fixed tags in WP directory

= 1.0 =
* First version released.
* Improved jQuery form builder published